const gulp = require('gulp');
const chartScripts = require('./gulp/chartScripts.js');
const mapScripts = require('./gulp/mapScripts.js');
const dataUtilityScripts = require('./gulp/dataUtilityScripts.js');
const depthGraphScripts = require('./gulp/depthGraphScripts.js');
const elevationGraphScripts = require('./gulp/elevationGraphScripts.js');
const pressureGraphScripts = require('./gulp/pressureGraphScripts.js');
const pumpingRateGraphScripts = require('./gulp/pumpingRateGraphScripts.js');
const pumpingvolumeGraphScripts = require('./gulp/pumpingvolumeGraphScripts.js');

gulp.task('chartScripts', chartScripts);
gulp.task('mapScripts', mapScripts);
gulp.task('dataUtilityScripts', dataUtilityScripts);
gulp.task('depthGraphScripts', depthGraphScripts);
gulp.task('elevationGraphScripts', elevationGraphScripts);
gulp.task('pressureGraphScripts', pressureGraphScripts);
gulp.task('pumpingRateGraphScripts', pumpingRateGraphScripts);
gulp.task('pumpingvolumeGraphScripts', pumpingvolumeGraphScripts);

function watchFiles() {
  gulp.watch('./src/js/charts.js', chartScripts);
  gulp.watch('./src/js/map.js', mapScripts);
  gulp.watch('./src/js/data-utilities.js', dataUtilityScripts);
  gulp.watch('./src/js/depthGraph.js', depthGraphScripts);
  gulp.watch('./src/js/elevationGraph.js', elevationGraphScripts);
  gulp.watch('./src/js/pressureGraph.js', pressureGraphScripts);
  gulp.watch('./src/js/pumpingrateGraph.js', pumpingRateGraphScripts);
  gulp.watch('./src/js/pumpingvolumeGraph.js', pumpingvolumeGraphScripts);  
}


gulp.task('default', gulp.series(watchFiles));
