var Dropdown = function(options, request) {
	var self = this;
	this.container = options.container;
	this.addClass = function(cssClass) {
		jQuery( self.container).addClass(cssClass);
	};
	this.loadDropdownData = function() {
		return jQuery.ajax(request);
	};
	this.buildDropdown = function(data) {
		jQuery( self.container ).addClass("js-dropdown");
		var response = JSON.parse(data);
		if (response) {
			var keys = Object.keys(response[0]);
			var valueKey = keys[options.valueIndex];
			var textKey = keys[options.textIndex];
			response.forEach(function(d) {
				var html = '<option value="' + d[valueKey]+ '">' + d[textKey] + '</option>';
				jQuery( self.container ).append(html);
			})

			if (typeof options.selectedValue != "undefined") {
				jQuery( self.container ).val(options.selectedValue);
				self.value = options.selectedValue;
			}

			self.data = response;
		}
	};
	this.setValue = function(value) {
		jQuery( this.container ).val(value);
	}
	this.getValue = function() {
		return jQuery( this.container ).val();
	};
	this.getText = function() {
		return jQuery( this.container + ' option:selected' ).text();
	};
	this.bindEvents = function() {
		jQuery( this.container ).on('change', options.onChange);
	};
	this.init = (function() {
		self.bindEvents();
		jQuery.when(self.loadDropdownData()).done(self.buildDropdown);
	})();
};

var Datepicker = function(options) {
	var self = this;
	this.container = options.container;
	this.addClass = function(cssClass) {
		jQuery( self.container).addClass(cssClass);
	};
	this.setDate = function(date, days) {
		if (typeof date == "undefined" && typeof days == "undefined") {
			var properDate = new Date();
			var newDateFormatted = properDate.getFullYear() + '-' + ("0" + (properDate.getMonth()+1)).slice(-2) + '-' + ("0" + (properDate.getDate())).slice(-2);
			jQuery( self.container ).val(newDateFormatted);
			jQuery( self.container ).val(newDateFormatted);
		} else if (typeof date == "number" && typeof days == "undefined") {
			var days = date;
			var properDate = new Date();
			var newDate = new Date(properDate.setDate(properDate.getDate() - days));
			var newDateFormatted = newDate.getFullYear() + '-' + ("0" + (newDate.getMonth()+1)).slice(-2) + '-' + ("0" + (newDate.getDate())).slice(-2);
			jQuery( self.container ).val(newDateFormatted)
		} else if (typeof date == "string" && typeof days != "undefined") {
			var properDate = new Date(date);
			var newDate = new Date(properDate.setDate(properDate.getDate() - days));
			var newDateFormatted = newDate.getFullYear() + '-' + ("0" + (newDate.getMonth()+1)).slice(-2) + '-' + ("0" + (newDate.getDate())).slice(-2);
			jQuery( self.container ).val(newDateFormatted)
		} else {
			jQuery( self.container ).val(date);
		}
	};
	this.getDate = function() {
		return jQuery( this.container ).val();
	};
	this.addDaysToDate = function(days) {
		var date = jQuery( this.container ).val();
		var newDate = new Date(date);
		var momentDate = moment(newDate).add(2, 'd');
		var formattedDate = momentDate.format('YYYY-MM-DD')
		return formattedDate;
	}
	this.formatDate = function(date) {
		var properDate = new Date(date);
		var formattedDate = (properDate.getMonth() + 1) + '/' + (properDate.getDate() + 1) + '/' + properDate.getFullYear();
		return formattedDate;
	};
	this.bindEvents = function() {
		jQuery( this.container ).on('change', options.onChange);
	};
	this.init = (function() {
		self.bindEvents();
	})();	
};